import { XInputGroup } from "./XInputGroup";
import { IgcXInputGroupItemComponent } from './igc-x-input-group-item-component';
import { IgcXInputGroupInputCollection } from './igc-x-input-group-input-collection';
import { InputGroupDisplayType } from './InputGroupDisplayType';
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
export declare class IgcXInputGroupComponent extends IgcHTMLElement {
    private _portalManager;
    private _container;
    private _renderer;
    contentInputs: IgcXInputGroupItemComponent[];
    /**
    * The style mappings actually present in the treemap. Do not directly modify this array.
    * This array's contents can be modified by causing Angular to reproject the child content.
    * Or adding and removing style mappings from the manual style mappings collection on the inputs property.
    */
    actualInputs: IgcXInputGroupItemComponent[];
    private _inputs;
    private _inputsAdapter;
    /**
     * A collection or manually added axes for the chart.
    */
    get inputs(): IgcXInputGroupInputCollection;
    constructor();
    private _onChildrenChanged;
    private updateInputs;
    updateStyle(): void;
    destroy(): void;
    private _wrapper;
    protected createImplementation(): XInputGroup;
    private _inputGroup;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): XInputGroup; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcXInputGroupComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcXInputGroupComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets the display style to use for the button.
*/
    get displayType(): InputGroupDisplayType;
    set displayType(v: InputGroupDisplayType);
    /**
     * Gets or sets the display density to use for the input group.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets the actual display density to use for the input group.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    /**
     * Gets or sets the base built in theme to use for the label.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    get inputHasValue(): boolean;
    /**
     * Gets the actual item background color.
    */
    get actualBorderColor(): string;
    set actualBorderColor(v: string);
    /**
     * Gets the actual item border color.
    */
    get actualFocusBorderColor(): string;
    set actualFocusBorderColor(v: string);
    /**
     * Gets the actual item border width.
    */
    get actualBorderWidth(): number;
    set actualBorderWidth(v: number);
    /**
     * Gets the actual item border width.
    */
    get actualFocusBorderWidth(): number;
    set actualFocusBorderWidth(v: number);
    get actualCornerRadiusBottomRight(): number;
    set actualCornerRadiusBottomRight(v: number);
    get actualCornerRadiusBottomLeft(): number;
    set actualCornerRadiusBottomLeft(v: number);
    get actualCornerRadiusTopLeft(): number;
    set actualCornerRadiusTopLeft(v: number);
    get actualCornerRadiusTopRight(): number;
    set actualCornerRadiusTopRight(v: number);
    ensureActualCornerRadius(): void;
    get actualContentPaddingBottom(): number;
    set actualContentPaddingBottom(v: number);
    get actualContentPaddingLeft(): number;
    set actualContentPaddingLeft(v: number);
    get actualContentPaddingRight(): number;
    set actualContentPaddingRight(v: number);
    get actualContentPaddingTop(): number;
    set actualContentPaddingTop(v: number);
    ensureActualContentPadding(): void;
    /**
     * Gets the actual width to use for the underline element.
    */
    get actualUnderlineWidth(): number;
    set actualUnderlineWidth(v: number);
    /**
     * Gets the actual width to use for the underline element.
    */
    get actualUnderlineRippleWidth(): number;
    set actualUnderlineRippleWidth(v: number);
    /**
     * Gets the width to use for the underline element when hovered.
    */
    get actualHoverUnderlineWidth(): number;
    set actualHoverUnderlineWidth(v: number);
    /**
     * Gets the actual color to use for the underline element.
    */
    get actualUnderlineColor(): string;
    set actualUnderlineColor(v: string);
    /**
     * Gets the actual color to use for the underline ripple element.
    */
    get actualUnderlineRippleColor(): string;
    set actualUnderlineRippleColor(v: string);
    /**
     * Gets the actual color to use for the underline element.
    */
    get actualHoverUnderlineColor(): string;
    set actualHoverUnderlineColor(v: string);
    /**
     * Gets the actual color to use for the underline element when focused.
    */
    get actualFocusUnderlineColor(): string;
    set actualFocusUnderlineColor(v: string);
    /**
     * Gets the actual opacity to use for the underline element.
    */
    get actualUnderlineOpacity(): number;
    set actualUnderlineOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline element when hovered.
    */
    get actualHoverUnderlineOpacity(): number;
    set actualHoverUnderlineOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline element when focused.
    */
    get actualFocusUnderlineOpacity(): number;
    set actualFocusUnderlineOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline ripple element when focused.
    */
    get actualFocusUnderlineRippleOpacity(): number;
    set actualFocusUnderlineRippleOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline ripple element.
    */
    get actualUnderlineRippleOpacity(): number;
    set actualUnderlineRippleOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline ripple element.
    */
    get actualBackgroundColor(): string;
    set actualBackgroundColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group.
    */
    get borderWidth(): number;
    set borderWidth(v: number);
    /**
     * Gets or sets the border width to use for the border of the item group when focused.
    */
    get focusBorderWidth(): number;
    set focusBorderWidth(v: number);
    /**
     * Gets or sets the color to use the border of the input group.
    */
    get borderColor(): string;
    set borderColor(v: string);
    get cornerRadiusBottomRight(): number;
    set cornerRadiusBottomRight(v: number);
    get cornerRadiusBottomLeft(): number;
    set cornerRadiusBottomLeft(v: number);
    get cornerRadiusTopLeft(): number;
    set cornerRadiusTopLeft(v: number);
    get cornerRadiusTopRight(): number;
    set cornerRadiusTopRight(v: number);
    ensureCornerRadius(): void;
    get contentPaddingBottom(): number;
    set contentPaddingBottom(v: number);
    get contentPaddingLeft(): number;
    set contentPaddingLeft(v: number);
    get contentPaddingRight(): number;
    set contentPaddingRight(v: number);
    get contentPaddingTop(): number;
    set contentPaddingTop(v: number);
    ensureContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element.
    */
    get underlineWidth(): number;
    set underlineWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element.
    */
    get underlineRippleWidth(): number;
    set underlineRippleWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when hovered.
    */
    get hoverUnderlineWidth(): number;
    set hoverUnderlineWidth(v: number);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get underlineColor(): string;
    set underlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element.
    */
    get underlineRippleColor(): string;
    set underlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get hoverUnderlineColor(): string;
    set hoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get focusUnderlineColor(): string;
    set focusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get underlineOpacity(): number;
    set underlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get hoverUnderlineOpacity(): number;
    set hoverUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get focusUnderlineOpacity(): number;
    set focusUnderlineOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused.
    */
    get focusUnderlineRippleOpacity(): number;
    set focusUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element.
    */
    get underlineRippleOpacity(): number;
    set underlineRippleOpacity(v: number);
    /**
     * Gets or sets the background color to use for the input group.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group when using type line.
    */
    get lineTypeBorderWidth(): number;
    set lineTypeBorderWidth(v: number);
    /**
     * Gets or sets the border width to use for the border of the item group when focused when type is line.
    */
    get lineTypeFocusBorderWidth(): number;
    set lineTypeFocusBorderWidth(v: number);
    /**
     * Gets or sets the focus color to use the border of the input group when type is line.
    */
    get lineTypeFocusBorderColor(): string;
    set lineTypeFocusBorderColor(v: string);
    /**
     * Gets or sets the color to use the border of the input group when type is line.
    */
    get lineTypeBorderColor(): string;
    set lineTypeBorderColor(v: string);
    get lineTypeCornerRadiusBottomRight(): number;
    set lineTypeCornerRadiusBottomRight(v: number);
    get lineTypeCornerRadiusBottomLeft(): number;
    set lineTypeCornerRadiusBottomLeft(v: number);
    get lineTypeCornerRadiusTopLeft(): number;
    set lineTypeCornerRadiusTopLeft(v: number);
    get lineTypeCornerRadiusTopRight(): number;
    set lineTypeCornerRadiusTopRight(v: number);
    ensureLineTypeCornerRadius(): void;
    get lineTypeContentPaddingBottom(): number;
    set lineTypeContentPaddingBottom(v: number);
    get lineTypeContentPaddingLeft(): number;
    set lineTypeContentPaddingLeft(v: number);
    get lineTypeContentPaddingRight(): number;
    set lineTypeContentPaddingRight(v: number);
    get lineTypeContentPaddingTop(): number;
    set lineTypeContentPaddingTop(v: number);
    ensureLineTypeContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element when type is line.
    */
    get lineTypeUnderlineWidth(): number;
    set lineTypeUnderlineWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when type is line.
    */
    get lineTypeUnderlineRippleWidth(): number;
    set lineTypeUnderlineRippleWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when hovered when type is line.
    */
    get lineTypeHoverUnderlineWidth(): number;
    set lineTypeHoverUnderlineWidth(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeUnderlineColor(): string;
    set lineTypeUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element when type is line.
    */
    get lineTypeUnderlineRippleColor(): string;
    set lineTypeUnderlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeHoverUnderlineColor(): string;
    set lineTypeHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeFocusUnderlineColor(): string;
    set lineTypeFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeUnderlineOpacity(): number;
    set lineTypeUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeHoverUnderlineOpacity(): number;
    set lineTypeHoverUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeFocusUnderlineOpacity(): number;
    set lineTypeFocusUnderlineOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused when type is line.
    */
    get lineTypeFocusUnderlineRippleOpacity(): number;
    set lineTypeFocusUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when type is line.
    */
    get lineTypeUnderlineRippleOpacity(): number;
    set lineTypeUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the background color to use for the input group when type is line.
    */
    get lineTypeBackgroundColor(): string;
    set lineTypeBackgroundColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group when using type line.
    */
    get boxTypeBorderWidth(): number;
    set boxTypeBorderWidth(v: number);
    /**
     * Gets or sets the border width to use for the border of the item group when focused when type is box.
    */
    get boxTypeFocusBorderWidth(): number;
    set boxTypeFocusBorderWidth(v: number);
    /**
     * Gets or sets the focus color to use the border of the input group when type is box.
    */
    get boxTypeFocusBorderColor(): string;
    set boxTypeFocusBorderColor(v: string);
    /**
     * Gets or sets the color to use the border of the input group when type is box.
    */
    get boxTypeBorderColor(): string;
    set boxTypeBorderColor(v: string);
    get boxTypeCornerRadiusBottomRight(): number;
    set boxTypeCornerRadiusBottomRight(v: number);
    get boxTypeCornerRadiusBottomLeft(): number;
    set boxTypeCornerRadiusBottomLeft(v: number);
    get boxTypeCornerRadiusTopLeft(): number;
    set boxTypeCornerRadiusTopLeft(v: number);
    get boxTypeCornerRadiusTopRight(): number;
    set boxTypeCornerRadiusTopRight(v: number);
    ensureBoxTypeCornerRadius(): void;
    get boxTypeContentPaddingBottom(): number;
    set boxTypeContentPaddingBottom(v: number);
    get boxTypeContentPaddingLeft(): number;
    set boxTypeContentPaddingLeft(v: number);
    get boxTypeContentPaddingRight(): number;
    set boxTypeContentPaddingRight(v: number);
    get boxTypeContentPaddingTop(): number;
    set boxTypeContentPaddingTop(v: number);
    ensureBoxTypeContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element when type is box.
    */
    get boxTypeUnderlineWidth(): number;
    set boxTypeUnderlineWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when type is box.
    */
    get boxTypeUnderlineRippleWidth(): number;
    set boxTypeUnderlineRippleWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when hovered when type is box.
    */
    get boxTypeHoverUnderlineWidth(): number;
    set boxTypeHoverUnderlineWidth(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeUnderlineColor(): string;
    set boxTypeUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element when type is box.
    */
    get boxTypeUnderlineRippleColor(): string;
    set boxTypeUnderlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeHoverUnderlineColor(): string;
    set boxTypeHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeFocusUnderlineColor(): string;
    set boxTypeFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeUnderlineOpacity(): number;
    set boxTypeUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeHoverUnderlineOpacity(): number;
    set boxTypeHoverUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeFocusUnderlineOpacity(): number;
    set boxTypeFocusUnderlineOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused when type is box.
    */
    get boxTypeFocusUnderlineRippleOpacity(): number;
    set boxTypeFocusUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when type is box.
    */
    get boxTypeUnderlineRippleOpacity(): number;
    set boxTypeUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the background color to use for the input group when type is box.
    */
    get boxTypeBackgroundColor(): string;
    set boxTypeBackgroundColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group when using type line.
    */
    get borderTypeBorderWidth(): number;
    set borderTypeBorderWidth(v: number);
    /**
     * Gets or sets the border width to use for the border of the item group when focused when type is border.
    */
    get borderTypeFocusBorderWidth(): number;
    set borderTypeFocusBorderWidth(v: number);
    /**
     * Gets or sets the focus color to use the border of the input group when type is border.
    */
    get borderTypeFocusBorderColor(): string;
    set borderTypeFocusBorderColor(v: string);
    /**
     * Gets or sets the color to use the border of the input group when type is border.
    */
    get borderTypeBorderColor(): string;
    set borderTypeBorderColor(v: string);
    get borderTypeCornerRadiusBottomRight(): number;
    set borderTypeCornerRadiusBottomRight(v: number);
    get borderTypeCornerRadiusBottomLeft(): number;
    set borderTypeCornerRadiusBottomLeft(v: number);
    get borderTypeCornerRadiusTopLeft(): number;
    set borderTypeCornerRadiusTopLeft(v: number);
    get borderTypeCornerRadiusTopRight(): number;
    set borderTypeCornerRadiusTopRight(v: number);
    ensureBorderTypeCornerRadius(): void;
    get borderTypeContentPaddingBottom(): number;
    set borderTypeContentPaddingBottom(v: number);
    get borderTypeContentPaddingLeft(): number;
    set borderTypeContentPaddingLeft(v: number);
    get borderTypeContentPaddingRight(): number;
    set borderTypeContentPaddingRight(v: number);
    get borderTypeContentPaddingTop(): number;
    set borderTypeContentPaddingTop(v: number);
    ensureBorderTypeContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element when type is border.
    */
    get borderTypeUnderlineWidth(): number;
    set borderTypeUnderlineWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when type is border.
    */
    get borderTypeUnderlineRippleWidth(): number;
    set borderTypeUnderlineRippleWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when hovered when type is border.
    */
    get borderTypeHoverUnderlineWidth(): number;
    set borderTypeHoverUnderlineWidth(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeUnderlineColor(): string;
    set borderTypeUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element when type is border.
    */
    get borderTypeUnderlineRippleColor(): string;
    set borderTypeUnderlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeHoverUnderlineColor(): string;
    set borderTypeHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeFocusUnderlineColor(): string;
    set borderTypeFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeUnderlineOpacity(): number;
    set borderTypeUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeHoverUnderlineOpacity(): number;
    set borderTypeHoverUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeFocusUnderlineOpacity(): number;
    set borderTypeFocusUnderlineOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused when type is border.
    */
    get borderTypeFocusUnderlineRippleOpacity(): number;
    set borderTypeFocusUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when type is border.
    */
    get borderTypeUnderlineRippleOpacity(): number;
    set borderTypeUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the background color to use for the input group when type is border.
    */
    get borderTypeBackgroundColor(): string;
    set borderTypeBackgroundColor(v: string);
    /**
     * Gets or sets the search width to use for the border of the item group when using type line.
    */
    get searchTypeBorderWidth(): number;
    set searchTypeBorderWidth(v: number);
    /**
     * Gets or sets the search width to use for the border of the item group when focused when type is search.
    */
    get searchTypeFocusBorderWidth(): number;
    set searchTypeFocusBorderWidth(v: number);
    /**
     * Gets or sets the focus color to use the search of the input group when type is search.
    */
    get searchTypeFocusBorderColor(): string;
    set searchTypeFocusBorderColor(v: string);
    /**
     * Gets or sets the color to use the search of the input group when type is search.
    */
    get searchTypeBorderColor(): string;
    set searchTypeBorderColor(v: string);
    get searchTypeCornerRadiusBottomRight(): number;
    set searchTypeCornerRadiusBottomRight(v: number);
    get searchTypeCornerRadiusBottomLeft(): number;
    set searchTypeCornerRadiusBottomLeft(v: number);
    get searchTypeCornerRadiusTopLeft(): number;
    set searchTypeCornerRadiusTopLeft(v: number);
    get searchTypeCornerRadiusTopRight(): number;
    set searchTypeCornerRadiusTopRight(v: number);
    ensureSearchTypeCornerRadius(): void;
    get searchTypeContentPaddingBottom(): number;
    set searchTypeContentPaddingBottom(v: number);
    get searchTypeContentPaddingLeft(): number;
    set searchTypeContentPaddingLeft(v: number);
    get searchTypeContentPaddingRight(): number;
    set searchTypeContentPaddingRight(v: number);
    get searchTypeContentPaddingTop(): number;
    set searchTypeContentPaddingTop(v: number);
    ensureSearchTypeContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element when type is search.
    */
    get searchTypeUnderlineWidth(): number;
    set searchTypeUnderlineWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when type is search.
    */
    get searchTypeUnderlineRippleWidth(): number;
    set searchTypeUnderlineRippleWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element when hovered when type is search.
    */
    get searchTypeHoverUnderlineWidth(): number;
    set searchTypeHoverUnderlineWidth(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeUnderlineColor(): string;
    set searchTypeUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element when type is search.
    */
    get searchTypeUnderlineRippleColor(): string;
    set searchTypeUnderlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeHoverUnderlineColor(): string;
    set searchTypeHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeFocusUnderlineColor(): string;
    set searchTypeFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeUnderlineOpacity(): number;
    set searchTypeUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeHoverUnderlineOpacity(): number;
    set searchTypeHoverUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeFocusUnderlineOpacity(): number;
    set searchTypeFocusUnderlineOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused when type is search.
    */
    get searchTypeFocusUnderlineRippleOpacity(): number;
    set searchTypeFocusUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when type is search.
    */
    get searchTypeUnderlineRippleOpacity(): number;
    set searchTypeUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the background color to use for the input group when type is search.
    */
    get searchTypeBackgroundColor(): string;
    set searchTypeBackgroundColor(v: string);
    /**
     * Gets or sets whether the input group is expanded or not.
    */
    get isExpanded(): boolean;
    set isExpanded(v: boolean);
    /**
     * Gets or sets whether the input group is hovered or not.
    */
    get isHovered(): boolean;
    set isHovered(v: boolean);
    /**
     * Gets or sets whether the input group is hovered or not.
    */
    get isFocused(): boolean;
    set isFocused(v: boolean);
    /**
     * Gets or sets whether the input group is expanded or not.
    */
    get actualIsExpanded(): boolean;
    set actualIsExpanded(v: boolean);
    /**
     * Gets or sets the color to use the hovered background of the inputs in the group.
    */
    get focusBorderColor(): string;
    set focusBorderColor(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
}
