import { XRipple } from "./XRipple";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
export declare class IgcXRippleComponent extends IgcHTMLElement {
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _top;
    private _left;
    set top(value: string);
    get top(): string;
    set left(value: string);
    get left(): string;
    private _position;
    set position(value: string);
    get position(): string;
    private _container;
    private _renderer;
    constructor();
    updateStyle(): void;
    destroy(): void;
    private _wrapper;
    protected createImplementation(): XRipple;
    private _ripple;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): XRipple; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcXRippleComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcXRippleComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets the target element to inject ripples into.
*/
    get eventSource(): any;
    set eventSource(v: any);
    /**
     * Gets or sets the color to use for the background when the checkbox is unchecked.
    */
    get rippleColor(): string;
    set rippleColor(v: string);
    /**
     * Gets or sets the color to use for the background when the ripple is hovered.
    */
    get hoverColor(): string;
    set hoverColor(v: string);
    /**
     * Gets or sets the actual color to use for the background when the ripple is hovered.
    */
    get actualHoverColor(): string;
    set actualHoverColor(v: string);
    /**
     * Gets or sets the color to use for the actual background when the checkbox is unchecked.
    */
    get actualRippleColor(): string;
    set actualRippleColor(v: string);
    /**
     * Gets or sets the duration to use for the ripple animation.
    */
    get rippleDuration(): number;
    set rippleDuration(v: number);
    /**
     * Gets or sets if the ripple is disabled.
    */
    get isDisabled(): boolean;
    set isDisabled(v: boolean);
    /**
     * Gets or sets if the ripple is centered.
    */
    get isCentered(): boolean;
    set isCentered(v: boolean);
    /**
     * Gets or sets if the ripple is centered.
    */
    get isHoverEnabled(): boolean;
    set isHoverEnabled(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
}
